--------------------------------------------------------
--  Arquivo criado - Segunda-feira-Dezembro-15-2014   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Procedure XREF
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "C_ERGON"."XREF" (SEL_OBJECT_NAME IN VARCHAR2)
AS
-- Autor:
-- Renato Viana http://br.linkedin.com/pub/renato-menezes-viana/35/573/11b/
-- Objetivo Forum:
-- http://glufke.net/oracle/viewtopic.php?f=4&t=9662
-- Observaes:
-- NO ESQUEA DE SEMPRE FORNECER SEL_OBJECT_NAME EM "CAIXA ALTA".
-- FONTES que possuem like 'SEL_OBJECT_NAME' so gerados na tabela Z_JAVA_SQL_XREF_DEPENDENCIES 
-- possue formato idntico ao Z_JAVA_SQL_XREF_TMP caso deseje usar o mesmo processo de "importar"
-- e executar a procedure XREF_SQL_JAVA_Z.
-- Documento Pblico com informaes:
-- https://drive.google.com/file/d/0B2rqwIwbyBy9ek5RNl95UXM2X2s/edit?usp=sharing


  sid                NUMBER;
  session_user       VARCHAR2(30);
  db_name            VARCHAR2(30);
  os_user            VARCHAR2(30);
  os_terminal        VARCHAR2(30);
  ip_address         VARCHAR2(30);

  v_set number;
  v_owner varchar2(30);
  v_object_name varchar2(30);
  v_object_type varchar2(30);
  v_procedure_name varchar2(30);


CURSOR AO is --- All Objects (No Data) [[[OK]]]
select b.owner, b.object_name, b.object_id, b.object_type from all_objects b
where b.owner IN (select owner from xrf_owners)
  and b.object_name like '%'||SEL_OBJECT_NAME||'%'
  and b.object_type <> 'SYNONYM' 
  and b.object_type <> 'PACKAGE'
  and b.status = 'VALID'
  and b.data_object_id is null  
  order by b.object_name, b.owner;


CURSOR APNN is --- All Procedures Name Null [[[OK]]]
select * from all_procedures
where object_name = v_object_name
  and owner = v_owner
  and procedure_name is null;
  

CURSOR PD IS  --- Public Dependency (No Data) [[[OK]]]
select * from (
SELECT distinct B.OBJECT_ID, 
   b.owner, 
   b.object_type TYPE, 
   b.object_name NAME,  
   b.status,  
   replace(b.object_type,' ','_') type_link, 
   b.owner sdev_link_owner, 
   b.object_name sdev_link_name, 
   b.object_type sdev_link_type 
FROM 
   sys.all_objects b, 
   (SELECT object_id, referenced_object_id 
    FROM public_dependency 
    START WITH object_id = v_set
    CONNECT BY NOCYCLE PRIOR referenced_object_id = object_id) c 
WHERE b.object_id = c.referenced_object_id 
AND b.owner NOT IN ('SYS', 'SYSTEM') 
AND b.object_type <> 'SYNONYM'
AND b.object_name <> 'DUAL'
AND ( (length (b.object_name) > 3 and SUBSTR(b.object_name,1,4) <> 'BIN$') --- Desprezar EXEC IMMEDIATE
    or length (b.object_name) < 4
    ) 
 ) sub1 order by 4,2;


CURSOR AOP is --- All Select Procedures Objects 
select * from xrf_dependencies
where status = 'VALID'
  and P_NAME is null
  and P_OBJECT_NAME <> NAME  
  and type <> 'TABLE'
  and type <> 'INDEX'
  and type <> 'SYNONYM'
  order by name, owner;


CURSOR AOD is --- All Select Data Objects 
select * from xrf_dependencies
where status = 'VALID'
  and P_NAME is null
  and (type = 'TABLE' or type = 'INDEX')
  order by name, owner;



CURSOR AD IS --- All Data Dependencies
SELECT distinct OWNER, NAME, TYPE, REFERENCED_OWNER, REFERENCED_NAME, REFERENCED_TYPE, OWNER SDEV_LINK_OWNER, NAME SDEV_LINK_NAME, TYPE SDEV_LINK_TYPE 
FROM ALL_DEPENDENCIES WHERE REFERENCED_OWNER = V_OWNER AND REFERENCED_NAME = V_OBJECT_NAME  AND TYPE <> 'SYNONYM' order by 2,1;


----- FASE II -------------- [[[OK]]] - cobrir referencia

CURSOR SAO is --- All Source Objects Procedures Names.Package (No Data)
select b.owner, b.object_name, b.object_id, b.object_type from all_objects b
where b.owner IN (select owner from xrf_owners)
  and b.object_name like '%'||SEL_OBJECT_NAME||'%'
  and b.object_type <> 'PACKAGE'
  and b.status = 'VALID'
  and b.data_object_id is null  
  order by b.object_name, b.owner;

CURSOR SPNP is --- All Source Procedures Names.Package (No Data)
select * from all_procedures
where object_name = v_object_name
  and owner = v_owner
---  and procedure_name is not null
  order by object_name, procedure_name, owner;


CURSOR SP IS --- All Source Procedures Names.Package (No Data) <--- Referenciado por
SELECT owner, name, line, type from all_source ----  v_owner, v_object_name, v_set, v_object_type;
where name <> v_object_name and type <> 'PACKAGE'
AND ( (length (name) > 3 and SUBSTR(name,1,4) <> 'BIN$') --- Desprezar EXEC IMMEDIATE
    or length (name) < 4
    ) 
  and UPPER(TEXT) like '%'||v_procedure_name||'%';

/* -- Tipos de FONTES e siglas semelhantes ao PL/SQL Developer (allroundautomations.com)
fnc - FUNCTION
java - JAVA SOURCE
pck - PACKAGE
pkb - PACKAGE BODY
prc - PROCEDURE
trg - TRIGGER
typ - TYPE
tyb - TYPE BODY
*/


CURSOR FONTES IS
select 'Z:\'||a.type||'\'||a.owner||'\'||a.name||'.'||
case a.type
when 'FUNCTION'     THEN 'fnc'
when 'JAVA SOURCE'  THEN 'java'
when 'PACKAGE'      THEN 'pck'
when 'PACKAGE BODY' THEN 'pkb'
when 'PROCEDURE'    THEN 'prc'
when 'TRIGGER'      THEN 'trg'
when 'TYPE'         THEN 'typ'
when 'TYPE BODY'    THEN 'tyb'
else 'unk'

end
as NMARQJAV, a.line as NRLIN, a.text as DCLIN from all_source a, 
(select distinct owner, name, type from all_source where owner in (select owner from xrf_owners) 
AND ( (length (name) > 3 and SUBSTR(name,1,4) <> 'BIN$') --- Desprezar EXEC IMMEDIATE
    or length (name) < 4
    ) 
and upper(text) like '%'||SEL_OBJECT_NAME||'%' 
order by name, owner, type) B
where a.owner = b.owner and a.name = b.name and a.type = b.type order by a.name, a.owner, a.type, a.line;

CURSOR LISTAFONTES IS
select distinct z_get_left_tag((z_get_right_tag(nmarqjav,'\')),'.') as OBJECT_NAME, nmarqjav from z_java_sql_xref_dependencies order by 1,2;

  
BEGIN

dbms_output.put_line(CURRENT_TIMESTAMP||' Seleo Like Object:'||sel_object_name);

      DELETE xrf_dependencies;
      
      
      SELECT SYS_CONTEXT( 'USERENV', 'SID' ) INTO sid FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'IP_ADDRESS' ) INTO ip_address FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'TERMINAL' ) INTO os_terminal FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'OS_USER' ) INTO os_user FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'DB_NAME' ) INTO db_name FROM DUAL;
      SELECT SYS_CONTEXT( 'USERENV', 'SESSION_USER' ) INTO session_user FROM DUAL;

    dbms_output.put_line('OS_USER:'||os_user);
    dbms_output.put_line('SESSION_USER:'||session_user);

/* ------- Teste Comprova que ALL_SOURCE no funciona 100% (idem ALL_OBJECTS)
  v_procedure_name := 'EP__RAIS_CONSIST_TOTALIZACAO1';

  open SP;
  loop
  fetch SP into v_owner, v_object_name, v_set, v_object_type;
  exit when SP%notfound;
  dbms_output.put_line(v_owner||v_object_name||v_set||v_object_type);
 
  end loop;
  close SP;
*/ 
 
commit;
    
  for a1 in AO loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.object_name;
  
  dbms_output.put_line(CURRENT_TIMESTAMP||' A1 = Owner:'||a1.owner||' Object_name:'||a1.object_name||' Object_id:'||a1.object_id);
  
  for b1 in APNN loop
  
  dbms_output.put_line(CURRENT_TIMESTAMP||' B1 = Owner:'||b1.owner||' Object_name:'||b1.object_name||' Object_id:'||b1.object_id);
  
  
  for c1 in PD loop
  
  

begin

---dbms_output.put_line('C1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.object_id);

  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.OBJECT_NAME
,b1.PROCEDURE_NAME
,a1.OBJECT_TYPE
,a1.OBJECT_ID
,c1.OWNER
,c1.NAME
,c1.TYPE
,c1.OBJECT_ID
,c1.STATUS
,c1.TYPE_LINK
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('DUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.object_id);

WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||a1.object_name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
  end loop; 

commit;
-----------------------------------------------------------------
dbms_output.put_line(CURRENT_TIMESTAMP||' FASE I OK:'||sqlerrm);
-----------------------------------------------------------------

/*
  open SAO;
  loop
  fetch SAO into v_owner, v_object_name, v_set, v_object_type;
  exit when SAO%notfound;
  v_set := v_set/10**Length(to_char(v_set));
  dbms_output.put_line('SAO:'||v_owner||v_object_name||v_set||v_object_type);
 
  end loop;
  close SAO;
*/ 

  for a1 in SAO loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.object_name;
  
---  dbms_output.put_line('SA1 = Owner:'||a1.owner||' Object_name:'||a1.object_name||' Object_id:'||a1.object_id);
  
  for b1 in SPNP loop
  
  if b1.procedure_name is not null then
  v_procedure_name := UPPER(b1.procedure_name);
  else
  v_procedure_name := UPPER(b1.object_name);
  end if;
  
---  dbms_output.put_line('SB1 = Owner:'||b1.owner||' Object_name:'||b1.object_name||' Object_id:'||b1.object_id||' Procedure:'||v_procedure_name);
  
  
  for c1 in SP loop
  
  

begin

--- dbms_output.put_line('SC1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.OBJECT_NAME
,b1.PROCEDURE_NAME
,a1.OBJECT_TYPE
,a1.OBJECT_ID
,c1.OWNER
,c1.NAME
,c1.TYPE
,b1.SUBPROGRAM_ID
,'<SUBPROGRAM | P_OBJECT_NAME>'
,a1.OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('SDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' SP_OWNER:'||a1.owner||' P_OBJECT_NAME:'||a1.object_name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
  end loop; 

commit;

dbms_output.put_line(CURRENT_TIMESTAMP||' FASE II OK:'||sqlerrm);


---------------------------------------------------------
--- Inicio da FASE III 
---------------------------------------------------------

  for a1 in AOP loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.name;
  
---  dbms_output.put_line('AOP = Owner:'||a1.owner||' name:'||a1.name||' Object_id:'||a1.object_id);
  
  for b1 in PD loop
  
  v_procedure_name := null;
  


begin

---- dbms_output.put_line('AOP1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.NAME
,null
,a1.TYPE
,a1.OBJECT_ID
,b1.OWNER
,b1.NAME
,b1.TYPE
,b1.OBJECT_ID
,'P_OBJECT_NAME>'
,a1.P_OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('AOPDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' AOP_OWNER:'||a1.owner||' NAME:'||a1.name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
 
commit;

dbms_output.put_line(CURRENT_TIMESTAMP||' FASE III OK:'||sqlerrm);


---------------------------------------------------------
--- Inicio da FASE IV
---------------------------------------------------------

  for a1 in AOD loop
 
  v_set := a1.object_id;
  v_owner := a1.owner;
  v_object_name := a1.name;
  
---  dbms_output.put_line('AOD = Owner:'||a1.owner||' name:'||a1.name||' Object_id:'||a1.object_id);
  
  for b1 in AD loop
  
  v_procedure_name := null;
  


begin

---- dbms_output.put_line('AOP1 = Owner:'||c1.owner||' Object_name:'||c1.name||' Object_id:'||c1.line);
                                                                                        --------------
  insert into xrf_dependencies
(
 P_OWNER
,P_OBJECT_NAME
,P_NAME
,P_TYPE
,P_OBJECT_ID
,OWNER
,NAME
,TYPE
,OBJECT_ID
,STATUS
,TYPE_LINK
)
values
(
 a1.OWNER
,a1.NAME
,null
,a1.TYPE
,a1.OBJECT_ID
,b1.OWNER
,b1.NAME
,b1.TYPE
,a1.P_OBJECT_ID
,'<P_OBJECT_ID | P_OBJECT_NAME>'
,a1.P_OBJECT_NAME ------------------------
);
EXCEPTION
WHEN DUP_VAL_ON_INDEX THEN NULL;
---dbms_output.put_line('AOPDUP = P_OWNER:'||a1.owner||' P_OBJECT_NAME:'||C1.name||' P_OBJECT_ID:'||c1.line);
                                                                                               ------------
WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' AOP_OWNER:'||a1.owner||' NAME:'||a1.name||' P_OBJECT_ID:'||a1.object_id||' ERRO:'||sqlerrm);
end;
        
  end loop;
  
  end loop;
  
 
commit;

dbms_output.put_line(CURRENT_TIMESTAMP||' FASE IV OK:'||sqlerrm);

delete Z_JAVA_SQL_XREF_DEPENDENCIES;

for a1 in FONTES LOOP

begin
insert into Z_JAVA_SQL_XREF_DEPENDENCIES
(
 NMARQJAV
,NRLIN 
,DCLIN
)
values
(
 a1.NMARQJAV
,a1.NRLIN 
,a1.DCLIN
);
EXCEPTION
WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' FONTES:'||a1.NMARQJAV||' NRLIN:'||a1.NRLIN||' ERRO:'||sqlerrm);
commit;
return;
end;
        
END LOOP;

commit;

dbms_output.put_line('Fontes SQL gerados em Z_JAVA_SQL_XREF_DEPENDENCIES');
dbms_output.put_line('--------------------------------------------------');
dbms_output.put_line(RPAD('OBJECT_NAME',30)||';'||'NMARQJAV');
dbms_output.put_line(RPAD('-----------',30)||';'||'--------');

for a1 in LISTAFONTES LOOP

dbms_output.put_line(RPAD(a1.object_name,30)||';'||a1.nmarqjav); 

END LOOP;

dbms_output.put_line(CURRENT_TIMESTAMP||' Termino Normal');

EXCEPTION
WHEN OTHERS THEN
dbms_output.put_line(CURRENT_TIMESTAMP||' ERRO:'||sqlerrm);
END;

/
--------------------------------------------------------
--  DDL for Procedure XREF_SQL_JAVA_Z
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "C_ERGON"."XREF_SQL_JAVA_Z" 
(
 XPsenha in out varchar2
 )
as
-- Autor:
-- Renato Viana http://br.linkedin.com/pub/renato-menezes-viana/35/573/11b/
-- Objetivo Forum:
-- http://glufke.net/oracle/viewtopic.php?f=4&t=9662
--
-- Documento Pblico com informaes:
-- https://drive.google.com/file/d/0B2rqwIwbyBy9ek5RNl95UXM2X2s/edit?usp=sharing

PRAGMA AUTONOMOUS_TRANSACTION;

--*====================================================================
--* Procedure..:  XREF_SQL_JAVA_Z
--* Descricao..:  Atualiza a Tabela Z_JAVA_SQL_XREF com as referncias cruzadas
--*               das Tabelas:
--*               ALL_tables, ALL_views, ALL_mviews, ALL_sequences,
--*               ALL_synonyms,
--*               ALL_procedures, pertencentes aos OWNERs existentes na XRF_OWNERS,
--*               alm de COMANDOS SQL, incluindo classes JPA Provider,
--*               e rastreamento classes Action pelo cruzamento com a Tabela
--*               Z_ROTINAS que abrigam as URLs das EAPs.
--*
--*               Para efeito de melhoria de performance as tabelas ALL_... mencionadas
--*               so sempre refeitas automaticamente por esta procedure como XRF_...
--*               contendo apenas as colunas necessrias a pesquisa e 
--*               eliminando qualquer duplicidade (OBJECT_NAME, OBJECT_NAME.PROCEDURE_NAME ou SYNONYM_NAME.TABLE_OWNER.TABLE_NAME),
--*               at mesmo SYNONYM_NAME = TABLE_NAME (destaca apenas os diferentes e TABLE_OWNER IN XRF_OWNERS).
--*
--*                um PRAGMA AUTONOMOUS_TRANSACTION onde seu commit no
--*               interfere na lgica de nenhuma outra aplicao.
--*               IMPORTANTE:
--*               ==========
--*               
--*               Existe apenas um parmetro de senha de execuo (IN/OUT).
--*               Macro Excel recebe o(s) Diretrio(s)  partir 
--*               do(s) qual(ais) sero extrados TODOS os arquivos FONTE (.java; .xml; e os .txt correspondentes aos:
--*               .fmb; .rdf; .mmb; .pll; .olb) gerando uma planilha Z_JAVA_SQL_XREF_TMP.xls para IMPORTAO na tabela
--*               Z_JAVA_SQL_XREF_TMP que possui colunas identicas, mas sem nehuma chave ou restrio.
--*               NO ESQUEA DE "ESVAZIAR" (truncar) Z_JAVA_SQL_XREF_TMP ANTES DA IMPORTAO!!!!!!!! 
--*
--*               Esta procedure faz INSERT  partir da _TMP na Tabela Z_JAVA_SQL_XREF removendo duplicidade do FONTE pela chave:
--*
--*               NMARQJAV - Nome do Arquivo JAVA (contem todo o path do arquivo C:\...\....java)
--*
--*               A outra componente da chave, NRLIN, como facilitador de localizao da referncia nos FONTES.
--*               IMPORTANTE FRISAR que a funo desta procedure e/ou Macros no  de manter FONTES.
--*               Assim apenas linhas significativas dos fontes so consideradas para pesquisas de Referncia Cruzada.
--*               Desta forma DCLIN - DesCrio da LINha (contedo) tambm  um componente de chave impedindo duplicidades
--*               desnecessrias de pesquisa.
--*             
--*               Por segurana o reset na Z_JAVA_SQL_XREF (Delete)  feito manualmente quando se
--*               desejar "refazer" o XREF devido o acmulo de manutenes nas estruturas SQL e/ou
--*               nos fontes JAVA (Classes Action e JPA Provider).
--*
--*               Ao final com o comando SQL abaixo  extraida uma Planilha Excel com as referncias
--*               SQL presentes nos fontes JAVA permitindo um rastreamento simples por Auto-Filtro.
--*
--*               Select * from Z_JAVA_SQL_XREF where 
--*               RCTABVIESEQ is not null or
--*               RCPROFUN    is not null or
--*               RCSQLCMD    is not null or
--*               RCSYN       is not null or 
--*               RCCLAJPA    is not null or
--*               RCCLAACT    is not null;
--*
--*               Recomendado exportar para Excel com o comando exemplo abaixo, onde  especificado o fonte e os comandos 
--*               de Auto-Filtro tero o mesmo efeito, mas ser possvel observar todo o fonte no perdendo as
--*               linhas significativas de lgica do cdigo. Apenas os "fontes" .TXT que correspondem aos .FMB
--*               sofrem "limpeza" mantendo apenas "linhas significativas":
--*
--*               Select * from Z_JAVA_SQL_XREF where upper(NMARQJAV) like '%FONTE.TXT%'
--*               order by NMARQJAV, NRLIN;
--*                
--*               Z_JAVA_SQL_XREF
--*
--*               NMARQJAV	VARCHAR2(2048)
--*               NRLIN	NUMBER(8)
--*               DCLIN	VARCHAR2(2048)
--*               RCTABVIESEQ	VARCHAR2(2048)
--*               RCPROFUN	VARCHAR2(2048)
--*               RCSQLCMD	VARCHAR2(2048)
--*               RCSYN	VARCHAR2(2048)
--*               RCCLAJPA	VARCHAR2(2048)
--*               RCCLAACT	VARCHAR2(2048)
--*                
--* Revises...:  Criacao da Procedure
--* Data.......:  22/08/2013
--* Autor .....:  Renato Viana
--* Revises...:
--* Data.......:
--* Autor Rev..:
--*=====================================================================
  
  XPfetchs    number(8);
  XPTAGROWID  ROWID;
  XPTAGNMARQ  VARCHAR2(2048);
  XPNMTAB     VARCHAR2(20);
  XP_JA_OUT   VARCHAR2(2048);
  XPEXCLEN    VARCHAR2(20);
  XPEXCOK     VARCHAR2(20);
  
------------ "Record Fetch" Cursor
XNMOBJ        VARCHAR2(256);
Xnmarqjav     VARCHAR2(2048); 
Xnrlin        NUMBER(8); 
Xdclin        VARCHAR2(2048); 
Xrctabvieseq  VARCHAR2(2048); 
Xrcprofun     VARCHAR2(2048); 
Xrcsqlcmd     VARCHAR2(2048); 
Xrcsyn        VARCHAR2(2048); 
Xrcclajpa     VARCHAR2(2048); 
Xrcclaact     VARCHAR2(2048);
Xrowid        ROWID;
  
------------ Cursores   
cursor FONTES_TMP is
SELECT distinct
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact
from z_java_sql_xref_tmp A
where A.nmarqjav is not null
and   A.dclin    is not null
and   A.nrlin    is not null
order by A.NMARQJAV, A.DCLIN, A.NRLIN; 


cursor XRFTABLES is
SELECT
B.OWNER,
B.TABLE_NAME

FROM ALL_TABLES B
WHERE B.TABLE_NAME is not null
AND B.OWNER IN (select owner from xrf_owners);


cursor sqlTABLES is
SELECT 
B.TABLE_NAME,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
XRF_TABLES B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.OWNER IN (select owner from xrf_owners)
AND UPPER(A.DCLIN) LIKE '%'||B.TABLE_NAME||'%'

order by a.nmarqjav, a.nrlin;

cursor XRFVIEW is
SELECT
B.OWNER,
B.VIEW_NAME

FROM ALL_VIEWS B
WHERE B.VIEW_NAME is not null
AND B.OWNER IN (select owner from xrf_owners);


cursor sqlVIEW is
SELECT 
B.VIEW_NAME,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
xrf_views B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.OWNER IN (select owner from xrf_owners)
AND UPPER(A.DCLIN) LIKE '%'||B.VIEW_NAME||'%'
order by a.nmarqjav, a.nrlin;

cursor XRFMVIEW is
SELECT
B.OWNER,
B.MVIEW_NAME

FROM ALL_MVIEWS B
WHERE B.MVIEW_NAME is not null
AND B.OWNER IN (select owner from xrf_owners);

cursor sqlMVIEW is
SELECT 
B.MVIEW_NAME,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
XRF_mviews B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.OWNER IN (select owner from xrf_owners)
AND UPPER(A.DCLIN) LIKE '%'||B.MVIEW_NAME||'%'
order by a.nmarqjav, a.nrlin;

cursor XRFSEQUENCES is
SELECT
B.SEQUENCE_OWNER,
B.SEQUENCE_NAME

FROM ALL_SEQUENCES B
WHERE B.SEQUENCE_NAME is not null
AND B.SEQUENCE_OWNER IN (select owner from xrf_owners);

cursor sqlSEQUENCES is
SELECT 
B.SEQUENCE_NAME,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
XRF_sequences B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.SEQUENCE_OWNER IN (select owner from xrf_owners)
AND UPPER(A.DCLIN) LIKE '%'||B.SEQUENCE_NAME||'%'
order by a.nmarqjav, a.nrlin;

cursor XRFSYNONYMS is
SELECT
B.OWNER,
B.SYNONYM_NAME,
B.TABLE_OWNER,
B.TABLE_NAME

FROM ALL_SYNONYMS B
WHERE B.SYNONYM_NAME is not null
AND B.TABLE_NAME is not null
AND B.SYNONYM_NAME <> B.TABLE_NAME
AND B.OWNER IN (select owner from xrf_owners)
AND B.TABLE_OWNER IN (select owner from xrf_owners);



cursor sqlSYNONYMS is
SELECT 
B.SYNONYM_NAME, 
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
XRF_SYNONYMS B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.SYNONYM_NAME is not null
AND B.TABLE_NAME is not null
AND B.SYNONYM_NAME <> B.TABLE_NAME
AND B.OWNER IN (select owner from xrf_owners)
AND B.TABLE_OWNER IN (select owner from xrf_owners)
AND UPPER(A.DCLIN) LIKE '%'||B.SYNONYM_NAME||'%'
order by a.nmarqjav, a.nrlin;

cursor XRFPROCEDURES is
SELECT
B.OWNER,
B.OBJECT_NAME,
B.PROCEDURE_NAME,
B.OBJECT_TYPE

FROM ALL_PROCEDURES B
WHERE B.OBJECT_NAME is not null
AND B.OWNER IN (select owner from xrf_owners);

cursor sqlPROCEDURES is
SELECT case when B.PROCEDURE_NAME is not null then B.object_name||'.'||B.PROCEDURE_NAME else B.object_name end,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid


FROM Z_JAVA_SQL_XREF A,
XRF_PROCEDURES B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND B.OWNER IN (select owner from xrf_owners)
AND ((B.PROCEDURE_NAME is null
      AND B.OBJECT_TYPE <> 'PACKAGE' 
      AND   UPPER(A.DCLIN) LIKE '%'||B.object_name||'%') 
  or (B.PROCEDURE_NAME is not null
      AND   UPPER(A.DCLIN) LIKE '%'||B.object_name||'.'||B.PROCEDURE_NAME||'%')
    )  
order by a.nmarqjav, a.nrlin;



cursor sqlCLAJPA is
SELECT
A.rctabvieseq, 
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A


WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND a.rcclajpa is null
AND UPPER(a.dclin) LIKE '%@%.CLASS%TABLE%'
order by a.nmarqjav, a.nrlin;

cursor sqlCKCLAJPA is
SELECT
B.rcclajpa,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
B.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
B.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
(SELECT rcclajpa, rctabvieseq, rcsyn from Z_JAVA_SQL_XREF
WHERE rcclajpa is not null) B

WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND a.rcclajpa is null
AND UPPER(a.dclin) LIKE '%'||UPPER(B.rcclajpa)||'%'
order by a.nmarqjav, a.nrlin;

cursor sqlCLAACT is
SELECT
B.dcrot,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid

FROM Z_JAVA_SQL_XREF A,
(select * from z_classeaction) B

WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND a.rcclaact is null
AND UPPER(a.dclin) LIKE '%'||UPPER(B.CLASSEACTION)||'%'
order by a.nmarqjav, a.nrlin;

cursor sqlJPACOMMANDS is
SELECT 
B.SQLCOMMAND,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid


FROM Z_JAVA_SQL_XREF A,
Z_JPACOMMANDS B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND A.rcclajpa is not null
AND   UPPER(A.DCLIN) LIKE '%'||B.JPACOMMANDS_NAME||'%'
order by a.nmarqjav, a.nrlin;

cursor sqlCOMMANDS is
SELECT 
B.SQL_COMMAND,
A.nmarqjav, 
A.nrlin, 
A.dclin, 
A.rctabvieseq, 
A.rcprofun, 
A.rcsqlcmd, 
A.rcsyn, 
A.rcclajpa, 
A.rcclaact,
A.rowid


FROM Z_JAVA_SQL_XREF A,
Z_SQLCOMMANDS B
WHERE A.DCLIN is not null
AND a.nmarqjav IN (select x.nmarqjav from z_java_sql_xref_tmp x where x.nmarqjav = A.nmarqjav and rownum = 1)
AND A.rcclajpa is null
AND   UPPER(A.DCLIN) LIKE '%'||B.SQL_COMMAND||'%'
order by a.nmarqjav, a.nrlin;

-------- Ja existindo informao agrega com vrgula, alm de impedir duplicidade
FUNCTION Z_JA_XNMOBJ(
  XZ_JA_OLD IN VARCHAR2,
  XZ_JA_NEW IN VARCHAR2 )
   RETURN VARCHAR2 AS
   XZ_JA_OUT VARCHAR2(2048);
     BEGIN
     
     if XZ_JA_OLD is null then
       RETURN XZ_JA_NEW;
     end if;
       
     if XZ_JA_NEW is null then
       RETURN XZ_JA_OLD;
     end if;
     
        
     XZ_JA_OUT := XZ_JA_OLD || ',' || XZ_JA_NEW;
     RETURN XZ_JA_OUT;
     
     EXCEPTION
     WHEN OTHERS THEN
          XPEXCLEN := 'OBJ LENGTH > '|| XPNMTAB;
          RETURN XZ_JA_OLD;
          
    END Z_JA_XNMOBJ;

-------- Informao ObjectSQL ALL_Tables realmente corresponde ao LIKE %
FUNCTION Z_OK_XNMOBJ (
  XZ_OK_DCLIN IN VARCHAR2,
  XZ_OK_XNMOBJ IN VARCHAR2 )
   RETURN BOOLEAN AS
   XZ_OK_EXISTE NUMBER := 0;
   XZ_OK_ONDE   NUMBER := 1;
   XZ_OK_VEZ    NUMBER := 1;
   XZ_OK_FIM    NUMBER := 1;
   XZ_OK_LEN    NUMBER := 0;

     BEGIN
     
          
     if XZ_OK_DCLIN is null
     or XZ_OK_XNMOBJ is null then
       RETURN FALSE;
     end if;
       
     if length(XZ_OK_XNMOBJ) > length(XZ_OK_DCLIN) then
       RETURN FALSE;
     end if;
     
     XZ_OK_FIM := length(XZ_OK_DCLIN);
     XZ_OK_LEN := length(XZ_OK_XNMOBJ);
     
     
     LOOP
       
       XZ_OK_ONDE := INSTR(UPPER(XZ_OK_DCLIN),XZ_OK_XNMOBJ,XZ_OK_ONDE,XZ_OK_VEZ);
       IF XZ_OK_ONDE > 0 THEN
         IF (XZ_OK_ONDE + XZ_OK_LEN - 1) = XZ_OK_FIM 
          OR XZ_OK_XNMOBJ || ' ' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))
          OR XZ_OK_XNMOBJ || '"' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))
          OR XZ_OK_XNMOBJ || '''' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))   
          OR XZ_OK_XNMOBJ || ',' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))  
          OR XZ_OK_XNMOBJ || ';' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))
          OR XZ_OK_XNMOBJ || ')' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))
          OR XZ_OK_XNMOBJ || '(' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1))
          OR XZ_OK_XNMOBJ || '.' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 19/9/2013
          OR XZ_OK_XNMOBJ || '=' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || '<' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || '>' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || ':' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || '%' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || '!' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          OR XZ_OK_XNMOBJ || '~' = UPPER(SUBSTR(XZ_OK_DCLIN,XZ_OK_ONDE,XZ_OK_LEN + 1)) -- 11/12/2014
          
         THEN
           XZ_OK_EXISTE := 1;
           RETURN TRUE;
         ELSE
           XZ_OK_VEZ := 2;
         END IF;
       ELSE
         XZ_OK_EXISTE := 0;
         RETURN FALSE;
       END IF;  
       
     END LOOP;
  
     RETURN FALSE;        
         
     EXCEPTION
     WHEN OTHERS THEN
          XPEXCOK := 'EXCEP OK OBJ ' || XPNMTAB;
          RETURN FALSE;
          
    END Z_OK_XNMOBJ; 

    
begin

If XPsenha <> 'pass69' then
   XPsenha := 'Err pass';
   return;
end if;

--------------------------------------------------------------
----- Transfere apenas o essencial das ALL_... para as XRF_...
--------------------------------------------------------------

----- Begin Cursor XRFTABLES
XPNMTAB := 'XRFTABLES';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_TABLES;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFTABLES LOOP

BEGIN
INSERT INTO XRF_TABLES
(
 owner     
,table_name        
        
)
values
(
 x1.owner     
,x1.table_name        
        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFTABLES

----- Begin Cursor XRFVIEW
XPNMTAB := 'XRFVIEW';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_VIEWS;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFVIEW LOOP

BEGIN
INSERT INTO XRF_VIEWS
(
 owner     
,view_name        
        
)
values
(
 x1.owner     
,x1.view_name        
        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFVIEW

----- Begin Cursor XRFMVIEW
XPNMTAB := 'XRFVMIEW';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_MVIEWS;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFMVIEW LOOP

BEGIN
INSERT INTO XRF_MVIEWS
(
 owner     
,mview_name        
        
)
values
(
 x1.owner     
,x1.mview_name        
        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFMVIEW

----- Begin Cursor XRFSEQUENCES
XPNMTAB := 'XRFSEQUENCES';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_SEQUENCES;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFSEQUENCES LOOP

BEGIN
INSERT INTO XRF_SEQUENCES
(
 sequence_owner     
,sequence_name        
        
)
values
(
 x1.sequence_owner     
,x1.sequence_name        
        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFSEQUENCES

----- Begin Cursor XRFSYNONYMS
XPNMTAB := 'XRFSYNONYMS';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_SYNONYMS;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFSYNONYMS LOOP

BEGIN
INSERT INTO XRF_SYNONYMS
(
 owner     
,synonym_name
,table_owner
,table_name
        
)
values
(
 x1.owner     
,x1.synonym_name
,x1.table_owner
,x1.table_name
        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFSYNONYMS

----- Begin Cursor XRFPROCEDURES
XPNMTAB := 'XRFPROCEDURES';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||' Deletando ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
delete XRF_PROCEDURES;
XPsenha := CURRENT_TIMESTAMP||' Opening ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

FOR X1 IN XRFPROCEDURES LOOP

BEGIN
INSERT INTO XRF_PROCEDURES
(
OWNER,
OBJECT_NAME,
PROCEDURE_NAME,
OBJECT_TYPE        
)
values
(
X1.OWNER,
X1.OBJECT_NAME,
X1.PROCEDURE_NAME,
X1.OBJECT_TYPE        
);
     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
----- END Cursor XRFPROCEDURES

---------------------------------------------------
----- Transfere fontes da _TMP para Z_JAVA_SQL_XREF
---------------------------------------------------

----- Begin Cursor FONTES_TMP
XPNMTAB := 'FONTES_TMP';
XPTAGNMARQ := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN FONTES_TMP;    
XPsenha := 'First Fetch ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
FETCH FONTES_TMP INTO
 Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact;     


XPsenha := 'Question END ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
WHILE FONTES_TMP%FOUND LOOP
    
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica delete fonte antigo
if XPTAGNMARQ is null 
or XPTAGNMARQ <> Xnmarqjav then
XPTAGNMARQ := Xnmarqjav;
XPsenha := 'Vai delete ' || Xnmarqjav; 
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
DELETE Z_JAVA_SQL_XREF 
WHERE nmarqjav = Xnmarqjav;
XPsenha := 'Deletou ' || Xnmarqjav; 
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
end if;


BEGIN

Xdclin := replace(Xdclin,chr(09),' ');
Xdclin := trim(Xdclin);
Xdclin := replace(Xdclin,'  ',' ');

if Xdclin is not null 
and ( ( upper(Z_get_right_tag((z_get_right_tag(Xnmarqjav,'\')),'.')) = 'TXT' --- Form Builder
        and substr(Xdclin,1,1) <> '-' and substr(Xdclin,1,1) <> '^')         --- despreza linhas - e ^
        
     or upper(Z_get_right_tag((z_get_right_tag(Xnmarqjav,'\')),'.')) <> 'TXT'
    )
then    

INSERT INTO Z_JAVA_SQL_XREF
(
 nmarqjav     
,nrlin        
,dclin        
)
values
(
 Xnmarqjav     
,Xnrlin        
,Xdclin        
);

end if;

     EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN
       null;
       WHEN OTHERS THEN
       XPSENHA := XPSENHA || sqlerrm;
       dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
       return;
END;       

FETCH FONTES_TMP INTO
 Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact;     


END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE FONTES_TMP; 
----- END Cursor FONTES_TMP

--- Remove e Recria Tabelas Bsicas de Classe Action e Commands SQL
--- ===============================================================
dbms_output.put_line('Deletando z_classeaction');
delete z_classeaction;
--- A tabela z_classeaction
--- Aqui TRANSACAO corresponde a uma tabela de "Rotinas do Sistema" em que se faz XREF contendo colunas:
--- DCURLROT = Descrio URL da Rotina que contem path da rotina JAVA que liga um Menu Web
---            responsvel pelo "disparo" das funcionalidades (Action) e que normalmente so
---            utilizados no nome das demais classes diretamente ligadas a funcionalida;
--- SIS      = Identificador do Sistema em que se faz XREF;
--- DCROT    = Descrio da Rotina Funcional (ID da EAP).
dbms_output.put_line('Inserindo z_classeaction');
insert into z_classeaction 
(CLASSEACTION, DCURLROT, DCROT)
(select 
case
when Z_GET_LEFT_TAG(ITEMMENU, '.do?evento') <> ITEMMENU
then  
  
Z_GET_LEFT_TAG(ITEMMENU, '.do?evento')

else
  
NVL(FORMTRANS,CHAVE)

end AS CLASSEACTION
,ITEMMENU AS DCURLROT
,TRANS||'-'||UPPER(SIS) AS DCROT from TRANSACAO where ITEMMENU is not null
 and UPPER(SIS) in (select owner from xrf_owners)

 );
commit; 
dbms_output.put_line('Commit z_classeaction');
--- Outras Tabelas Mencionadas nos Cursores:
--- =======================================
--- Estas tabelas no so removidas ou recriadas aqui neste cdigo.
--- Elas so mantidas externamente em funo das necessidades de rastreamento.
---
--- Z_JPACOMMANDS
--- 
--- JPACOMMANDS_NAME  SQLCOMMAND
--- ================  ==========
--- .UPDATE         	UPDATE
--- .MERGE	          UPDATE
--- .SAVE   	        UPDATE
--- .PERSIST        	UPDATE
--- .DELETE 	        DELETE
---
--- Z_SQLCOMMANDS
---
--- SQL_COMMAND
--- ===========
--- CREATE
--- DELETE
--- DROP
--- GRANT
--- INSERT
--- JOIN
--- SELECT
--- UNION
--- UPDATE
--- ALTER




----- Begin Cursor TABLES
XPNMTAB := 'sqlTABLES';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlTABLES;    
XPsenha := 'First Fetch ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
FETCH sqlTABLES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
WHILE sqlTABLES%FOUND LOOP
    
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rctabvieseq 
INTO  Xrctabvieseq
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

XPsenha := 'Verifica ' || XNMOBJ || ' ' || XPfetchs; 

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrctabvieseq,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrctabvieseq,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;


UPDATE Z_JAVA_SQL_XREF
SET rctabvieseq = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlTABLES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlTABLES; 
----- END Cursor TABLES

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);


----- Begin Cursor VIEW
XPNMTAB := 'sqlVIEW';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlVIEW;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlVIEW INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlVIEW%FOUND LOOP

XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rctabvieseq 
INTO  Xrctabvieseq
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrctabvieseq,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrctabvieseq,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rctabvieseq = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlVIEW INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlVIEW; 
----- END Cursor VIEW

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha); 

----- Begin Cursor MVIEW (O uso deste cursor pode ser dispensado qdo TABLES o contiver)
XPNMTAB := 'sqlMVIEW';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlMVIEW;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlMVIEW INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlMVIEW%FOUND LOOP
  
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rctabvieseq 
INTO  Xrctabvieseq
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrctabvieseq,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrctabvieseq,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rctabvieseq = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlMVIEW INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlMVIEW; 
----- END Cursor MVIEW

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlSEQUENCES
XPNMTAB := 'sqlSEQUENCES';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlSEQUENCES;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlSEQUENCES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlSEQUENCES%FOUND LOOP

XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rctabvieseq 
INTO  Xrctabvieseq
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrctabvieseq,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrctabvieseq,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rctabvieseq = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlSEQUENCES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlSEQUENCES; 
----- END Cursor sqlSEQUENCES

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlSYNONYMS
XPNMTAB := 'sqlSYNONYMS';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlSYNONYMS;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlSYNONYMS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlSYNONYMS%FOUND LOOP

XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcsyn 
INTO  Xrcsyn
FROM z_java_sql_xref
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcsyn,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcsyn,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcsyn = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlSYNONYMS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlSYNONYMS; 
----- END Cursor sqlSYNONYMS

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlPROCEDURES
XPNMTAB := 'sqlPROCEDURES';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlPROCEDURES;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlPROCEDURES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlPROCEDURES%FOUND LOOP

XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcprofun 
INTO  Xrcprofun
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcprofun,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcprofun,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcprofun = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlPROCEDURES INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlPROCEDURES; 
----- END Cursor sqlPROCEDURES

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlCLAJPA
XPNMTAB := 'sqlCLAJPA';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlCLAJPA;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlCLAJPA INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlCLAJPA%FOUND LOOP
    
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcclajpa
INTO  Xrcclajpa
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,Xrctabvieseq) 
OR Z_OK_XNMOBJ(Xdclin,Xrcsyn) THEN

--- Cria o OBJ JPA utilizando a nomenclatura do arquivo
XNMOBJ := UPPER(Z_get_left_tag((z_get_right_tag(Xnmarqjav,'\')),'.'));

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcclajpa,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcclajpa,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcclajpa = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlCLAJPA INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlCLAJPA; 
----- END Cursor sqlCLAJPA

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlCKCLAJPA (Onde a CLAJPA montada anteriormente possui referencia)
XPNMTAB := 'sqlCKCLAJPA';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlCKCLAJPA;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlCKCLAJPA INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlCKCLAJPA%FOUND LOOP
  
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcclajpa 
INTO  Xrcclajpa
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcclajpa,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcclajpa,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcclajpa = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlCKCLAJPA INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlCKCLAJPA; 
----- END Cursor sqlCKCLAJPA

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
<<CLASSE>>

----- Begin Cursor sqlCLAACT
XPNMTAB := 'sqlCLAACT';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlCLAACT;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlCLAACT INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlCLAACT%FOUND LOOP
 
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

XNMOBJ := UPPER(XNMOBJ);
--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcclaact 
INTO  Xrcclaact
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- NO Verifica se o OBJ  Realmente Vlido 
--- === pois, aqui a finalidade  rastrear proximidade (LIKE) com a classe ACTION
--- === alm do que, o OBJ POSICIONADO  o ID DA EAP correlacionada a classe ACTION
IF Z_OK_XNMOBJ(XNMOBJ,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcclaact,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcclaact,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcclaact = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlCLAACT INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlCLAACT; 
----- END Cursor sqlCLAACT

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlJPACOMMANDS
XPNMTAB := 'sqlJPACOMMANDS';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlJPACOMMANDS;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlJPACOMMANDS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlJPACOMMANDS%FOUND LOOP
   
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

XNMOBJ := UPPER(XNMOBJ);
--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcsqlcmd
INTO  Xrcsqlcmd
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- NO Verifica se o OBJ  Realmente Vlido 
--- === pois, aqui a finalidade  rastrear proximidade (LIKE) com a commands JPA
--- === alm do que, o OBJ POSICIONADO  um command SQL
IF Z_OK_XNMOBJ(XNMOBJ,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcsqlcmd,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcsqlcmd,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcsqlcmd = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlJPACOMMANDS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlJPACOMMANDS; 
----- END Cursor sqlJPACOMMANDS

dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

----- Begin Cursor sqlCOMMANDS
XPNMTAB := 'sqlCOMMANDS';
XPTAGROWID := null;
XPfetchs := 0;
XPsenha := CURRENT_TIMESTAMP||'Open ' || XPNMTAB;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
OPEN sqlCOMMANDS;    
XPsenha := 'First Fetch ' || XPNMTAB;
FETCH sqlCOMMANDS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

XPsenha := 'Question END ' || XPNMTAB;

WHILE sqlCOMMANDS%FOUND LOOP
   
XPfetchs := XPfetchs + 1;
XPsenha := 'Fetch ' || XPNMTAB || ' ' || XPfetchs;

--- Verifica necessidade de Recuperao Fecth devido a um possvel UPDATE
if XPTAGROWID = Xrowid then
XPsenha := 'Select ' || XPNMTAB || ' ' || XPfetchs;  
SELECT rcsqlcmd
INTO  Xrcsqlcmd
FROM Z_JAVA_SQL_XREF
WHERE ROWID = Xrowid;
end if;

--- Verifica se o OBJ  Realmente Vlido
IF Z_OK_XNMOBJ(Xdclin,XNMOBJ) THEN

--- O novo objeto OK, J existindo na(s) SADA(s), ou seja, no(s) XP_JA_OUT,
--- significa que NO DEVE NOVAMENTE SER ADICIONADO evitando duplicidade.
     
IF NOT Z_OK_XNMOBJ(Xrcsqlcmd,XNMOBJ) THEN


XP_JA_OUT := Z_JA_XNMOBJ(Xrcsqlcmd,XNMOBJ);
XPsenha := 'Update ' || XPNMTAB || ' ' || XPfetchs;
  
UPDATE Z_JAVA_SQL_XREF
SET rcsqlcmd = XP_JA_OUT
WHERE ROWID = Xrowid;

END IF;

--- Guarda Rowid para teste de Recuperao Fetch aps UPDATE
XPTAGROWID := Xrowid;


END IF;

FETCH sqlCOMMANDS INTO
XNMOBJ
,Xnmarqjav     
,Xnrlin        
,Xdclin        
,Xrctabvieseq  
,Xrcprofun     
,Xrcsqlcmd    
,Xrcsyn        
,Xrcclajpa     
,Xrcclaact     
,Xrowid;

END LOOP;
XPsenha := 'COMMIT ' || XPNMTAB;
COMMIT;
XPsenha := 'Close ' || XPNMTAB;
CLOSE sqlCOMMANDS; 
----- END Cursor sqlCOMMANDS
XPSENHA:= CURRENT_TIMESTAMP||XPSENHA;
dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);

dbms_output.put_line('Termino Normal');

return;

     EXCEPTION
       WHEN OTHERS THEN
         XPSENHA := XPSENHA || sqlerrm;
         dbms_output.put_line(XPNMTAB||'-'||XPfetchs||'-'||XPsenha);
         return;

end;

/
