--------------------------------------------------------
--  Arquivo criado - Segunda-feira-Dezembro-15-2014   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Table XRF_DEPENDENCIES
--------------------------------------------------------

  CREATE TABLE "XRF_DEPENDENCIES" ("P_OWNER" VARCHAR2(30), "P_OBJECT_NAME" VARCHAR2(30), "P_NAME" VARCHAR2(30), "P_TYPE" VARCHAR2(30), "P_OBJECT_ID" NUMBER, "OWNER" VARCHAR2(30), "NAME" VARCHAR2(30), "TYPE" VARCHAR2(30), "OBJECT_ID" NUMBER, "STATUS" VARCHAR2(30), "TYPE_LINK" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_MVIEWS
--------------------------------------------------------

  CREATE TABLE "XRF_MVIEWS" ("OWNER" VARCHAR2(30), "MVIEW_NAME" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_OWNERS
--------------------------------------------------------

  CREATE TABLE "XRF_OWNERS" ("OWNER" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_PROCEDURES
--------------------------------------------------------

  CREATE TABLE "XRF_PROCEDURES" ("OWNER" VARCHAR2(30), "OBJECT_NAME" VARCHAR2(30), "PROCEDURE_NAME" VARCHAR2(30), "OBJECT_TYPE" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_SEQUENCES
--------------------------------------------------------

  CREATE TABLE "XRF_SEQUENCES" ("SEQUENCE_OWNER" VARCHAR2(30), "SEQUENCE_NAME" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_SYNONYMS
--------------------------------------------------------

  CREATE TABLE "XRF_SYNONYMS" ("OWNER" VARCHAR2(30), "SYNONYM_NAME" VARCHAR2(30), "TABLE_OWNER" VARCHAR2(30), "TABLE_NAME" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_TABLES
--------------------------------------------------------

  CREATE TABLE "XRF_TABLES" ("OWNER" VARCHAR2(30), "TABLE_NAME" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table XRF_VIEWS
--------------------------------------------------------

  CREATE TABLE "XRF_VIEWS" ("OWNER" VARCHAR2(30), "VIEW_NAME" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table Z_CLASSEACTION
--------------------------------------------------------

  CREATE TABLE "Z_CLASSEACTION" ("CLASSEACTION" VARCHAR2(256), "DCURLROT" VARCHAR2(2048), "DCROT" VARCHAR2(2048))
/
--------------------------------------------------------
--  DDL for Table Z_JAVA_SQL_XREF
--------------------------------------------------------

  CREATE TABLE "Z_JAVA_SQL_XREF" ("NMARQJAV" VARCHAR2(2048), "NRLIN" NUMBER(8,0), "DCLIN" VARCHAR2(2048) DEFAULT '--', "RCTABVIESEQ" VARCHAR2(2048), "RCPROFUN" VARCHAR2(2048), "RCSQLCMD" VARCHAR2(2048), "RCSYN" VARCHAR2(2048), "RCCLAJPA" VARCHAR2(2048), "RCCLAACT" VARCHAR2(2048))
/
--------------------------------------------------------
--  DDL for Table Z_JAVA_SQL_XREF_DEPENDENCIES
--------------------------------------------------------

  CREATE TABLE "Z_JAVA_SQL_XREF_DEPENDENCIES" ("NMARQJAV" VARCHAR2(2048), "NRLIN" NUMBER(8,0), "DCLIN" VARCHAR2(2048), "RCTABVIESEQ" VARCHAR2(2048), "RCPROFUN" VARCHAR2(2048), "RCSQLCMD" VARCHAR2(2048), "RCSYN" VARCHAR2(2048), "RCCLAJPA" VARCHAR2(2048), "RCCLAACT" VARCHAR2(2048))
/
--------------------------------------------------------
--  DDL for Table Z_JAVA_SQL_XREF_TMP
--------------------------------------------------------

  CREATE TABLE "Z_JAVA_SQL_XREF_TMP" ("NMARQJAV" VARCHAR2(2048), "NRLIN" NUMBER(8,0), "DCLIN" VARCHAR2(2048), "RCTABVIESEQ" VARCHAR2(2048), "RCPROFUN" VARCHAR2(2048), "RCSQLCMD" VARCHAR2(2048), "RCSYN" VARCHAR2(2048), "RCCLAJPA" VARCHAR2(2048), "RCCLAACT" VARCHAR2(2048))
/
--------------------------------------------------------
--  DDL for Table Z_JPACOMMANDS
--------------------------------------------------------

  CREATE TABLE "Z_JPACOMMANDS" ("JPACOMMANDS_NAME" VARCHAR2(30), "SQLCOMMAND" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Table Z_SQLCOMMANDS
--------------------------------------------------------

  CREATE TABLE "Z_SQLCOMMANDS" ("SQL_COMMAND" VARCHAR2(30))
/
--------------------------------------------------------
--  DDL for Index XRF_DEPENDENCIES_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_DEPENDENCIES_PK" ON "XRF_DEPENDENCIES" ("P_OWNER", "P_OBJECT_NAME", "P_TYPE", "P_OBJECT_ID", "OWNER", "NAME", "TYPE", "OBJECT_ID")
/
--------------------------------------------------------
--  DDL for Index XRF_MVIEWS_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_MVIEWS_PK" ON "XRF_MVIEWS" ("MVIEW_NAME")
/
--------------------------------------------------------
--  DDL for Index XRF_OWNERS_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_OWNERS_PK" ON "XRF_OWNERS" ("OWNER")
/
--------------------------------------------------------
--  DDL for Index XRF_SEQUENCES_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_SEQUENCES_PK" ON "XRF_SEQUENCES" ("SEQUENCE_NAME")
/
--------------------------------------------------------
--  DDL for Index XRF_SYNONYMS_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_SYNONYMS_PK" ON "XRF_SYNONYMS" ("SYNONYM_NAME")
/
--------------------------------------------------------
--  DDL for Index XRF_TABLES_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_TABLES_PK" ON "XRF_TABLES" ("TABLE_NAME")
/
--------------------------------------------------------
--  DDL for Index XRF_VIEWS_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "XRF_VIEWS_PK" ON "XRF_VIEWS" ("VIEW_NAME")
/
--------------------------------------------------------
--  DDL for Index Z_JAVA_SQL_XREF_PK
--------------------------------------------------------

  CREATE UNIQUE INDEX "Z_JAVA_SQL_XREF_PK" ON "Z_JAVA_SQL_XREF" ("NMARQJAV", "DCLIN")
/
--------------------------------------------------------
--  Constraints for Table XRF_DEPENDENCIES
--------------------------------------------------------

  ALTER TABLE "XRF_DEPENDENCIES" ADD CONSTRAINT "XRF_DEPENDENCIES_PK" PRIMARY KEY ("P_OWNER", "P_OBJECT_NAME", "P_TYPE", "P_OBJECT_ID", "OWNER", "NAME", "TYPE", "OBJECT_ID") ENABLE
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("TYPE_LINK" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("STATUS" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("OBJECT_ID" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("TYPE" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("OWNER" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("P_OBJECT_ID" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("P_TYPE" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("P_OBJECT_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_DEPENDENCIES" MODIFY ("P_OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_MVIEWS
--------------------------------------------------------

  ALTER TABLE "XRF_MVIEWS" ADD CONSTRAINT "XRF_MVIEWS_PK" PRIMARY KEY ("MVIEW_NAME") ENABLE
  ALTER TABLE "XRF_MVIEWS" MODIFY ("MVIEW_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_MVIEWS" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_OWNERS
--------------------------------------------------------

  ALTER TABLE "XRF_OWNERS" ADD CONSTRAINT "XRF_OWNERS_PK" PRIMARY KEY ("OWNER") ENABLE
  ALTER TABLE "XRF_OWNERS" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_PROCEDURES
--------------------------------------------------------

  ALTER TABLE "XRF_PROCEDURES" MODIFY ("OBJECT_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_PROCEDURES" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_SEQUENCES
--------------------------------------------------------

  ALTER TABLE "XRF_SEQUENCES" ADD CONSTRAINT "XRF_SEQUENCES_PK" PRIMARY KEY ("SEQUENCE_NAME") ENABLE
  ALTER TABLE "XRF_SEQUENCES" MODIFY ("SEQUENCE_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_SEQUENCES" MODIFY ("SEQUENCE_OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_SYNONYMS
--------------------------------------------------------

  ALTER TABLE "XRF_SYNONYMS" MODIFY ("TABLE_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_SYNONYMS" MODIFY ("TABLE_OWNER" NOT NULL ENABLE)
  ALTER TABLE "XRF_SYNONYMS" ADD CONSTRAINT "XRF_SYNONYMS_PK" PRIMARY KEY ("SYNONYM_NAME") ENABLE
  ALTER TABLE "XRF_SYNONYMS" MODIFY ("SYNONYM_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_SYNONYMS" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_TABLES
--------------------------------------------------------

  ALTER TABLE "XRF_TABLES" ADD CONSTRAINT "XRF_TABLES_PK" PRIMARY KEY ("TABLE_NAME") ENABLE
  ALTER TABLE "XRF_TABLES" MODIFY ("TABLE_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_TABLES" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table XRF_VIEWS
--------------------------------------------------------

  ALTER TABLE "XRF_VIEWS" ADD CONSTRAINT "XRF_VIEWS_PK" PRIMARY KEY ("VIEW_NAME") ENABLE
  ALTER TABLE "XRF_VIEWS" MODIFY ("VIEW_NAME" NOT NULL ENABLE)
  ALTER TABLE "XRF_VIEWS" MODIFY ("OWNER" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_CLASSEACTION
--------------------------------------------------------

  ALTER TABLE "Z_CLASSEACTION" MODIFY ("DCROT" NOT NULL ENABLE)
  ALTER TABLE "Z_CLASSEACTION" MODIFY ("DCURLROT" NOT NULL ENABLE)
  ALTER TABLE "Z_CLASSEACTION" MODIFY ("CLASSEACTION" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_JAVA_SQL_XREF
--------------------------------------------------------

  ALTER TABLE "Z_JAVA_SQL_XREF" ADD CONSTRAINT "Z_JAVA_SQL_XREF_PK" PRIMARY KEY ("NMARQJAV", "DCLIN") ENABLE
  ALTER TABLE "Z_JAVA_SQL_XREF" MODIFY ("DCLIN" NOT NULL ENABLE)
  ALTER TABLE "Z_JAVA_SQL_XREF" MODIFY ("NRLIN" NOT NULL ENABLE)
  ALTER TABLE "Z_JAVA_SQL_XREF" MODIFY ("NMARQJAV" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_JAVA_SQL_XREF_DEPENDENCIES
--------------------------------------------------------

  ALTER TABLE "Z_JAVA_SQL_XREF_DEPENDENCIES" MODIFY ("NRLIN" NOT NULL ENABLE)
  ALTER TABLE "Z_JAVA_SQL_XREF_DEPENDENCIES" MODIFY ("NMARQJAV" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_JAVA_SQL_XREF_TMP
--------------------------------------------------------

  ALTER TABLE "Z_JAVA_SQL_XREF_TMP" MODIFY ("NRLIN" NOT NULL ENABLE)
  ALTER TABLE "Z_JAVA_SQL_XREF_TMP" MODIFY ("NMARQJAV" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_JPACOMMANDS
--------------------------------------------------------

  ALTER TABLE "Z_JPACOMMANDS" MODIFY ("SQLCOMMAND" NOT NULL ENABLE)
  ALTER TABLE "Z_JPACOMMANDS" MODIFY ("JPACOMMANDS_NAME" NOT NULL ENABLE)
/
--------------------------------------------------------
--  Constraints for Table Z_SQLCOMMANDS
--------------------------------------------------------

  ALTER TABLE "Z_SQLCOMMANDS" MODIFY ("SQL_COMMAND" NOT NULL ENABLE)
/
